
TYPO3.Flow - Bug # 25902

Status: Resolved Priority: Must have
Author: Bastian Waidelich Category: Persistence
Created: 2011-04-12 Assigned To: Karsten Dambekalns
Updated: 2011-05-02 Due date:
PHP Version:
Has patch:
Complexity:
Affected Flow version:
Description

It's very common to redirect to a details view after creating an entity:

1public function createAction(Foo $foo) {
2    $this->fooRepository->add($foo);
3    $this->redirect('show', NULL, NULL, array('foo' => $foo))
4}

But that won't work because the entity is not (yet) known to the Persistence Manager, which is asked for the identity of the object in
the Route in order to convert Objects to Identity arrays:

...
1if (is_object($routeValue)) {
2    $uuid = $this->persistenceManager->getIdentifierByObject($routeValue);

...

Related issues:
related to TYPO3.Flow - Bug # 25801: Request arguments should never contain o... Resolved 2011-04-06
related to TYPO3.Neos - Task # 25803: NodeRoutePartHandler should not return ... Resolved 2011-04-06

Associated revisions
Revision c7f66e08 - 2011-04-28 12:02 - Karsten Dambekalns

[BUGFIX] Make sure entities can be used in links/redirect

Now the Doctrine\PersistenceManager also checks for the FLOW3 identifier
introduced by AOP in getIdentifierByObject().

Fixes: #25902
Change-Id: I8a5547ab34732c4c6db5369da14337cb3b7a3047

History
#1 - 2011-04-13 09:55 - Bastian Waidelich
- Priority changed from Should have to Must have

Additional notes:
Calling

1$this->persistenceManager->persistAll();

before redirecting solves the issue temporarily but I have the same issue for updates, where this work around has no effect, so this is a real blocker
currently:

1public function updateAction(Foo $foo) {
2     $this->fooRepository->update($foo);
3     $this->redirect('show', NULL, NULL, array('foo' => $foo))
4}

#2 - 2011-04-13 11:32 - Karsten Dambekalns
- Status changed from New to Accepted
- Target version set to 1.0 beta 1

#3 - 2011-04-27 13:47 - Karsten Dambekalns
- % Done changed from 0 to 40

Partly solved, as new entities now have an identifier for their whole lifetime (generated through AOP).

Leaves the update case open...

#4 - 2011-04-28 12:02 - Mr. Hudson

Patch set 1 of change I8a5547ab34732c4c6db5369da14337cb3b7a3047 has been pushed to the review server.
It is available at http://review.typo3.org/1773

#5 - 2011-04-28 12:08 - Karsten Dambekalns
- Status changed from Accepted to Under Review

#6 - 2011-05-02 21:00 - Karsten Dambekalns
- Status changed from Under Review to Resolved
- % Done changed from 40 to 100

Applied in changeset commit:c7f66e0867f6de610706e1a53d64554852157e40.
